#
# Copyright (C) 2018-2019 de4dot@gmail.com
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

# ⚠️This file was generated by GENERATOR!🦹‍♂️

# pylint: disable=invalid-name
# pylint: disable=line-too-long
# pylint: disable=too-many-lines

"""
``RFLAGS`` bits, FPU condition code bits and misc bits (``UIF``) supported by the instruction info code
"""

from typing import List

NONE: int = 0x0000_0000
"""
No bit is set
"""
OF: int = 0x0000_0001
"""
``RFLAGS.OF``
"""
SF: int = 0x0000_0002
"""
``RFLAGS.SF``
"""
ZF: int = 0x0000_0004
"""
``RFLAGS.ZF``
"""
AF: int = 0x0000_0008
"""
``RFLAGS.AF``
"""
CF: int = 0x0000_0010
"""
``RFLAGS.CF``
"""
PF: int = 0x0000_0020
"""
``RFLAGS.PF``
"""
DF: int = 0x0000_0040
"""
``RFLAGS.DF``
"""
IF: int = 0x0000_0080
"""
``RFLAGS.IF``
"""
AC: int = 0x0000_0100
"""
``RFLAGS.AC``
"""
UIF: int = 0x0000_0200
"""
``UIF``
"""
C0: int = 0x0000_0400
"""
FPU status word bit ``C0``
"""
C1: int = 0x0000_0800
"""
FPU status word bit ``C1``
"""
C2: int = 0x0000_1000
"""
FPU status word bit ``C2``
"""
C3: int = 0x0000_2000
"""
FPU status word bit ``C3``
"""

__all__: List[str] = []
